struct MOPPHeader (
	version,
	crc,
	chunkcount,
	unk,
	fl,
	on create do if fl !=undefined then (
		version = readlong fl #unsigned
		crc = readlong fl #unsigned
		chunkcount = readlong fl #unsigned
		unk = readlong fl #unsigned
	)
)

struct MOPPChunk (
	faceoffset,
	facecount,
	MOPPID,
	vertexoffset = 0,
	vertexcount,
	fl,
	on create do if fl !=undefined then (
		offset = readlong fl #unsigned
		facecount = readlong fl #unsigned
		MOPPID = readlong fl #unsigned
		vertexcount = readlong fl #unsigned
	)
)

fn MOPPRuntime fl = (
	header = MOPPHeader fl:fl
	chunks = #()
	for h = 1 to header.chunkcount do (
		chnk = MOPPChunk fl:fl
		if h > 1 then (
			chnk.vertexoffset = chunks[h-1].vertexcount+chunks[h-1].vertexoffset
			chnk.vertexcount -= chnk.vertexoffset
			
		)
		append chunks chnk
	)
	mshvtp = #()
	mshfcs = #()
	for m in chunks do append mshvtp  (for p = 1 to m.vertexcount collect [readfloat fl,readfloat fl,readfloat fl]*30)
	readlong fl
	for m in chunks do append mshfcs (for p = 1 to m.facecount collect [readshort fl #unsigned,readshort fl #unsigned,readshort fl #unsigned]+1)
	for h = 1 to header.chunkcount do mesh vertices:mshvtp[h] faces:mshfcs[h]
	free chunks
	free mshvtp
	free mshfcs
)

txfile = getOpenFileName caption:"Open MOPP" types:"MOPP|*.MOPP|All|*.*" historyCategory:"RDHGMOPP"
		if txfile != undefined then (
			fl = fopen txfile "rb"
			if fl != undefined then (
				MOPPRuntime fl
				fclose fl
			)
			else MessageBox "Cannot open file."
		)